JavaScript Data GridLanguage

Set Handsontable's UI language to one of the built-in translations, or create your own language set using our templates.

Overview

You can easily change the text of the UI for the purpose of translating it to specific languages. We provide the developer with predefined languages, which can be applied by loading the language set and changing just one setting, and an ability to use their own language sets, created using templates of existing language files.

TIP

To properly display RTL languages, configure Handsontable's layout direction.

Load the prepared language files

To properly use the internationalization feature, you need to load the language sets. It's important that they're included after the Handsontable files. You can do it by getting the necessary files created with the UMD standard:

  1. ES modules (ESM)
import Handsontable from 'handsontable/base';
import { registerLanguageDictionary, deDE } from 'handsontable/i18n';

registerLanguageDictionary(deDE);

const hot = new Handsontable(container, {
  language: deDE.languageCode,
});
  1. CommonJS (CJS)
const Handsontable = require('handsontable/base').default;
const { registerLanguageDictionary, deDE } = require('handsontable/i18n');

registerLanguageDictionary(deDE);

const hot = new Handsontable(container, {
  language: deDE.languageCode,
});
  1. Universal Module Definition (UMD)

Languages included this way are ready to use immediately after loading the file. Each file contains a UMD loader that looks for Handsontable in a global/externals context. If Handsontable is available then it registers itself in the proper context.

<script type="text/javascript" src="dist/handsontable.full.js"></script>
<script type="text/javascript" src="dist/languages/de-DE.js"></script>
<script>
  const hot = new Handsontable(container, {
    language: 'de-DE',
  });
</script>

Demo

To see the translated context menu, right-click on a cell.

Language files were loaded after loading Handsontable.

    List of translatable features

    Below is a list of features which can be translated:

    • Dropdown menu
    • Filtering
    • Hiding columns
    • Hiding rows
    • Nesting rows
    • Comments
    • Context menu
    • Custom borders
    • Freezing
    • Merge cells
    • Read-only

    List of available languages

    By default, Handsontable uses the English - United States language-country set (en-US code) for creating the text of UI elements. However, it can be used like every extra, "non-standard" language file, thus the en-US.js file can be found in /dist/languages, /languages and /src/languages folders. Currently, we also distribute extra language-country files:

    • ar-AR.js for Arabic - Global (ar-AR code). To render this language as intended, set the layout direction to RTL.
    • cs-CZ.js for Czech - Czechia (cs-CZ code).
    • de-CH.js for German - Switzerland (de-CH code).
    • de-DE.js for German - Germany (de-DE code).
    • es-MX.js for Spanish - Mexico (es-MX code).
    • fr-FR.js for French - France (fr-FR code).
    • hr-HR.js for Croatian - Croatia (hr-HR code).
    • it-IT.js for Italian - Italy (it-IT code).
    • ja-JP.js for Japanese - Japan (ja-JP code).
    • ko-KR.js for Korean - Korea (ko-KR code).
    • lv-LV.js for Latvian - Latvia (lv-LV code).
    • nb-NO.js for Norwegian (Bokmål) - Norway (nb-NO code).
    • nl-NL.js for Dutch - Netherlands (nl-NL code).
    • pl-PL.js for Polish - Poland (pl-PL code).
    • pt-BR.js for Portuguese - Brazil (pt-BR code).
    • ru-RU.js for Russian - Russia (ru-RU code).
    • sr-SP.js for Serbian (Latin) - Serbia (sr-SP code).
    • zh-CN.js for Chinese - China (zh-CN code).
    • zh-TW.js for Chinese - Taiwan (zh-TW code).

    Create custom languages

    You can create custom language sets for your implementations, or share them, as they're easily applicable to any Handsontable implementation.

    Language file

    It's really important for us, that the community is a important part of the growth of our library. We encourage you to create and share your translations!

    Additional languages files should be placed in the src/i18n/languages folder of the Handsontable repository with name corresponding to the chosen language code (described below, for example: es-VE.js). You can incorporate your translations to the Handsontable library by sending us a pull request. It's important, that your changes are not made to the /languages and /dist/languages directories! We will generate the final files to be placed there. After that, you'll be able to use the languages in Handsontable.

    You can see a full template of a sample language at the bottom of this paragraph. We're basing it on our default language pack (opens new window). Parts of the file creation process are described below.

    1. The file should start with a comment containing the translation authors (separated by commas, for example: Authors: Chris Wick, John Kyle), "last updated" date (in format: mmm dd, yyyy, for example: Last updated: Jan 01, 2017) and a description.

      /**
      * @preserve
      * Authors: Chris Wick, John Kyle
      * Last updated: Nov 15, 2017
      *
      * Description: Definition file for Spanish - Venezuela language-country.
      */
      
    2. Now, import the dictionary keys to be used in the translation.

      import * as C from '../constants';
      
    3. The language dictionary object should contain a languageCode key (in format: two lowercase letters, hyphen, two uppercase letters, for example: languageCode: 'es-PY') which will determine the language code to be used in the language property in the Handsontable settings and dictionaries keys with their corresponding translations.

      const dictionary = {
        languageCode: 'es-VE',
        [C.CONTEXTMENU_ITEMS_ROW_ABOVE]: 'Insertar fila arriba',
        ...
      }
      
    4. Lastly, place a default export of the created dictionary.

      export default dictionary;
      
    5. A simple, sample language dictionary can look like the snippet below. The /languages and /dist/languages folders will be generated by the build process. Files from those localizations can be included as shown in this section. After loading them, you will be able to use the language. You can do it by changing the language setting of Handsontable to es-VE.

      /**
      * @preserve
      * Authors: Chris Wick, John Kyle
      * Last updated: Nov 15, 2017
      *
      * Description: Definition file for Spanish - Venezuela language-country.
      */
      import * as C from '../constants';
      
      const dictionary = {
        languageCode: 'es-VE',
        [C.CONTEXTMENU_ITEMS_ROW_ABOVE]: 'Insertar fila arriba',
      };
      
      export default dictionary;
      
    6. Import already created file inside the src/i18n/languages/index.js file and export it like it's shown in the snippet below (keys in a alphabetical order).




       






       






































      import deCH from './de-CH';
      import deDE from './de-DE';
      import enUS from './en-US';
      import esVE from './es-VE';
      import plPL from './pl-PL';
      
      export {
        deCH,
        deDE,
        enUS,
        esVE,
        plPL
      };
      
    7. Voilà! You've created a language which can be used just by you or shared with others. We wait for at least 5 positive feedback from users to accept a created pull request.

    Local language

    You can register a language dictionary which is not a part of the Handsontable package. To do so, use the static Handsontable.languages.registerLanguageDictionary method and the static constant Handsontable.languages.dictionaryKeys which are described briefly in the next section.

    const C = Handsontable.languages.dictionaryKeys;
    
    Handsontable.languages.registerLanguageDictionary({
      languageCode: 'morse',
      // Your translation in the Morse code
      [C.FILTERS_BUTTONS_OK]: '--- -•-'
    });
    

    Use custom keys in the translation

    You can register a language dictionary containing custom keys. These entries can be used like any other keys, so you're not limited to using our pre-defined constants (the ones that are present within src/i18n/constants.js file and may be accessed by Handsontable.languages.dictionaryKeys alias).

    const enUSDictionary = Handsontable.languages.getLanguageDictionary('en-US');
    
    enUSDictionary.customKey = 'Hello world';
    
    Handsontable.languages.registerLanguageDictionary(enUSDictionary); // re-registration
    Handsontable.languages.getTranslatedPhrase('en-US', 'customKey'); // 'Hello world'
    

    Static Handsontable methods and properties

    Handsontable has a few static methods and properties connected with languages. They are stored in the languages key of the global Handsontable variable. All of them are described below.

    Get language dictionary for specific language code

    Handsontable.languages.getLanguageDictionary(languageCode: String)

    Returns: Object

    Get the registered language dictionaries

    Handsontable.languages.getLanguagesDictionaries()

    Returns: Array

    Get the phrase for specified dictionary key

    Handsontable.languages.getTranslatedPhrase(languageCode: String, dictionaryKey: String, extraArguments: Mixed)

    Returns: Object

    Register a language dictionary for a specific language code

    Handsontable.languages.registerLanguageDictionary(languageCodeOrDictionary: Mixed, dictionary: Object)

    Returns: Object

    Dictionary constants

    Handsontable.languages.dictionaryKeys

    Contains: Object

Skip to content

Language

Set Handsontable’s UI language to one of the built-in translations, or create your own language set using our templates.

Overview

You can easily change the text of the UI for the purpose of translating it to specific languages. We provide the developer with predefined languages, which can be applied by loading the language set and changing just one setting, and an ability to use their own language sets, created using templates of existing language files.

Load the prepared language files

To properly use the internationalization feature, you need to load the language sets. It’s important that they’re included after the Handsontable files. You can do it by getting the necessary files created with the UMD standard:

  1. ES modules (ESM)

    import { ref } from 'vue';
    import { HotTable } from '@handsontable/vue3';
    import { registerAllModules } from 'handsontable/registry';
    import { registerLanguageDictionary, deDE } from 'handsontable/i18n';
    registerAllModules();
    registerLanguageDictionary(deDE);
    const hotSettings = ref({
    language: deDE.languageCode,
    });
    <HotTable :settings="hotSettings" />

Demo

To see the translated context menu, right-click on a cell.

Language files were loaded after loading Handsontable.

Vue
<script setup lang="ts">
import { ref } from 'vue';
import { HotTable } from '@handsontable/vue3';
import { registerAllModules } from 'handsontable/registry';
import { registerLanguageDictionary, deDE } from 'handsontable/i18n';
import type { GridSettings } from 'handsontable/settings';
registerAllModules();
registerLanguageDictionary(deDE);
const hotSettings = ref<GridSettings>({
data: [
['Lorem', 'ipsum', 'dolor', 'sit', '12/1/2015', 23],
['adipiscing', 'elit', 'Ut', 'imperdiet', '5/12/2015', 6],
['Pellentesque', 'vulputate', 'leo', 'semper', '10/23/2015', 26],
['diam', 'et', 'malesuada', 'libero', '12/1/2014', 98],
['orci', 'et', 'dignissim', 'hendrerit', '12/1/2016', 8.5],
],
contextMenu: true,
height: 'auto',
language: deDE.languageCode,
autoWrapRow: true,
autoWrapCol: true,
licenseKey: 'non-commercial-and-evaluation',
});
</script>
<template>
<div id="example1">
<HotTable :settings="hotSettings" />
</div>
</template>

List of translatable features

Below is a list of features which can be translated:

  • Alignment
  • Comments
  • Context menu
  • Cut and Copy (along with headers)
  • Custom borders
  • Dropdown menu
  • Filtering
  • Freezing
  • Hiding columns
  • Hiding rows
  • Merge cells
  • Nesting rows
  • Pagination
  • Read-only
  • Undo and Redo
  • Dialogs (including Loading indicator)

List of available languages

By default, Handsontable uses the English - United States language-country set (en-US code) for creating the text of UI elements. However, it can be used like every extra, “non-standard” language file, thus the en-US.js file can be found in /dist/languages, /languages and /src/languages folders. Currently, we also distribute extra language-country files:

Language fileLanguageCodeNote
ar-AR.jsArabic - Globalar-ARSet the layout direction to RTL
cs-CZ.jsCzech - Czechiacs-CZ
de-CH.jsGerman - Switzerlandde-CH
de-DE.jsGerman - Germanyde-DE
es-MX.jsSpanish - Mexicoes-MX
fa-IR.jsPersian - Iranfa-IR
fr-FR.jsFrench - Francefr-FR
hr-HR.jsCroatian - Croatiahr-HR
it-IT.jsItalian - Italyit-IT
ja-JP.jsJapanese - Japanja-JPEnable imeFastEdit for better editing experience
ko-KR.jsKorean - Koreako-KREnable imeFastEdit for better editing experience
lv-LV.jsLatvian - Latvialv-LV
nb-NO.jsNorwegian (Bokmål) - Norwaynb-NO
nl-NL.jsDutch - Netherlandsnl-NL
pl-PL.jsPolish - Polandpl-PL
pt-BR.jsPortuguese - Brazilpt-BR
ru-RU.jsRussian - Russiaru-RU
sr-SP.jsSerbian (Latin) - Serbiasr-SP
zh-CN.jsChinese - Chinazh-CNEnable imeFastEdit for better editing experience
zh-TW.jsChinese - Taiwanzh-TWEnable imeFastEdit for better editing experience

Create custom languages

You can create custom language sets for your implementations, or share them, as they’re easily applicable to any Handsontable implementation.

Language file

It’s really important for us, that the community is a important part of the growth of our library. We encourage you to create and share your translations!

Additional languages files should be placed in the src/i18n/languages folder of the Handsontable repository with name corresponding to the chosen language code (described below, for example: es-VE.js). You can incorporate your translations to the Handsontable library by sending us a pull request. It’s important, that your changes are not made to the /languages and /dist/languages directories! We will generate the final files to be placed there. After that, you’ll be able to use the languages in Handsontable.

You can see a full template of a sample language at the bottom of this paragraph. We’re basing it on our default language pack. Parts of the file creation process are described below.

  1. Add a file header comment

    The file should start with a comment containing the translation authors (separated by commas, for example: Authors: Chris Wick, John Kyle), “last updated” date (in format: mmm dd, yyyy, for example: Last updated: Jan 01, 2017) and a description.

    /**
    * @preserve
    * Authors: Chris Wick, John Kyle
    * Last updated: Nov 15, 2017
    *
    * Description: Definition file for Spanish - Venezuela language-country.
    */
  2. Import the dictionary keys

    Import the dictionary keys to be used in the translation.

    import * as C from '../constants';
  3. Create the language dictionary object

    The language dictionary object should contain a languageCode key (in format: two lowercase letters, hyphen, two uppercase letters, for example: languageCode: ‘es-PY’) which will determine the language code to be used in the language property in the Handsontable settings and dictionaries keys with their corresponding translations.

    const dictionary = {
    languageCode: 'es-VE',
    [C.CONTEXTMENU_ITEMS_ROW_ABOVE]: 'Insertar fila arriba',
    ...
    }
  4. Export the dictionary

    Place a default export of the created dictionary.

    export default dictionary;
  5. Review the complete file

    A simple, sample language dictionary can look like the snippet below. The /languages and /dist/languages folders will be generated by the build process. Files from those localizations can be included as shown in this section. After loading them, you will be able to use the language. You can do it by changing the language setting of Handsontable to es-VE.

    /**
    * @preserve
    * Authors: Chris Wick, John Kyle
    * Last updated: Nov 15, 2017
    *
    * Description: Definition file for Spanish - Venezuela language-country.
    */
    import * as C from '../constants';
    const dictionary = {
    languageCode: 'es-VE',
    [C.CONTEXTMENU_ITEMS_ROW_ABOVE]: 'Insertar fila arriba',
    };
    export default dictionary;
  6. Register the file in the index

    Import the already created file inside the src/i18n/languages/index.js file and export it like it’s shown in the snippet below (keys in a alphabetical order).

    import deCH from './de-CH';
    import deDE from './de-DE';
    import enUS from './en-US';
    import esVE from './es-VE';
    import plPL from './pl-PL';
    export {
    deCH,
    deDE,
    enUS,
    esVE,
    plPL
    };
  7. Share your translation

    You’ve created a language which can be used just by you or shared with others. We wait for at least 5 positive feedback from users to accept a created pull request.

Local language

You can register a language dictionary which is not a part of the Handsontable package. To do so, use the static Handsontable.languages.registerLanguageDictionary method and the static constant Handsontable.languages.dictionaryKeys which are described briefly in the next section.

const C = Handsontable.languages.dictionaryKeys;
Handsontable.languages.registerLanguageDictionary({
languageCode: 'morse',
// Your translation in the Morse code
[C.FILTERS_BUTTONS_OK]: '--- -•-'
});

Use custom keys in the translation

You can register a language dictionary containing custom keys. These entries can be used like any other keys, so you’re not limited to using our pre-defined constants (the ones that are present within src/i18n/constants.js file and may be accessed by Handsontable.languages.dictionaryKeys alias).

const enUSDictionary = Handsontable.languages.getLanguageDictionary('en-US');
enUSDictionary.customKey = 'Hello world';
Handsontable.languages.registerLanguageDictionary(enUSDictionary); // re-registration
Handsontable.languages.getTranslatedPhrase('en-US', 'customKey'); // 'Hello world'

Static Handsontable methods and properties

Handsontable has a few static methods and properties connected with languages. They are stored in the languages key of the global Handsontable variable. All of them are described below.

Get language dictionary for specific language code

Handsontable.languages.getLanguageDictionary(languageCode: String)

Returns: Object

Get the registered language dictionaries

Handsontable.languages.getLanguagesDictionaries()

Returns: Array

Get the phrase for specified dictionary key

Handsontable.languages.getTranslatedPhrase(languageCode: String, dictionaryKey: String, extraArguments: Mixed)

Returns: Object

Register a language dictionary for a specific language code

Handsontable.languages.registerLanguageDictionary(languageCodeOrDictionary: Mixed, dictionary: Object)

Returns: Object

Dictionary constants

Handsontable.languages.dictionaryKeys

Contains: Object

Related guides

Configuration options

Core methods

Hooks

React Data GridLanguage

Set Handsontable's UI language to one of the built-in translations, or create your own language set using our templates.

Overview

You can easily change the text of the UI for the purpose of translating it to specific languages. We provide the developer with predefined languages, which can be applied by loading the language set and changing just one setting, and an ability to use their own language sets, created using templates of existing language files.

TIP

To properly display RTL languages, configure Handsontable's layout direction.

Load the prepared language files

To properly use the internationalization feature, you need to load the language sets. It's important that they're included after the Handsontable files. You can do it by getting the necessary files created with the UMD standard:

  1. ES modules (ESM)
import Handsontable from 'handsontable/base';
import { HotTable } from '@handsontable/react-wrapper';
import { registerLanguageDictionary, deDE } from 'handsontable/i18n';

registerLanguageDictionary(deDE);

const App = () => {
  return (
    <HotTable
      language={deDE.languageCode}
    />
  );
};
  1. CommonJS (CJS)
const Handsontable = require('handsontable/base').default;
const { registerLanguageDictionary, deDE } = require('handsontable/i18n');

registerLanguageDictionary(deDE);

const App = () => {
  return (
    <HotTable
      language={deDE.languageCode}
    />
});

Demo

To see the translated context menu, right-click on a cell.

Language files were loaded after loading Handsontable.

import { HotTable } from '@handsontable/react-wrapper';
import { registerAllModules } from 'handsontable/registry';
import { registerLanguageDictionary, deDE } from 'handsontable/i18n';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();
registerLanguageDictionary(deDE);

const ExampleComponent = () => {
  return (
    <HotTable
      themeName="ht-theme-main"
      data={[
        ['Lorem', 'ipsum', 'dolor', 'sit', '12/1/2015', 23],
        ['adipiscing', 'elit', 'Ut', 'imperdiet', '5/12/2015', 6],
        ['Pellentesque', 'vulputate', 'leo', 'semper', '10/23/2015', 26],
        ['diam', 'et', 'malesuada', 'libero', '12/1/2014', 98],
        ['orci', 'et', 'dignissim', 'hendrerit', '12/1/2016', 8.5],
      ]}
      contextMenu={true}
      height="auto"
      language="de-DE"
      autoWrapRow={true}
      autoWrapCol={true}
      licenseKey="non-commercial-and-evaluation"
    />
  );
};

export default ExampleComponent;

import { useState, useEffect } from 'react';
import { HotTable } from '@handsontable/react-wrapper';
import {
  registerLanguageDictionary,
  getLanguagesDictionaries,
  arAR,
  csCZ,
  deCH,
  deDE,
  esMX,
  frFR,
  hrHR,
  itIT,
  jaJP,
  koKR,
  lvLV,
  nbNO,
  nlNL,
  plPL,
  ptBR,
  ruRU,
  srSP,
  zhCN,
  zhTW,
} from 'handsontable/i18n';
import { registerAllModules } from 'handsontable/registry';
import 'handsontable/styles/handsontable.css';
import 'handsontable/styles/ht-theme-main.css';

// register Handsontable's modules
registerAllModules();
registerLanguageDictionary(arAR);
registerLanguageDictionary(csCZ);
registerLanguageDictionary(deCH);
registerLanguageDictionary(deDE);
registerLanguageDictionary(esMX);
registerLanguageDictionary(frFR);
registerLanguageDictionary(hrHR);
registerLanguageDictionary(itIT);
registerLanguageDictionary(jaJP);
registerLanguageDictionary(koKR);
registerLanguageDictionary(lvLV);
registerLanguageDictionary(nbNO);
registerLanguageDictionary(nlNL);
registerLanguageDictionary(plPL);
registerLanguageDictionary(ptBR);
registerLanguageDictionary(ruRU);
registerLanguageDictionary(srSP);
registerLanguageDictionary(zhCN);
registerLanguageDictionary(zhTW);

const ExampleComponent = () => {
  const [language, setLanguage] = useState('en-US');
  const [languageList, setLanguageList] = useState([]);

  useEffect(() => {
    setLanguageList(getLanguagesDictionaries());
  }, []);

  const updateHotLanguage = (event) => {
    setLanguage(event.target.value);
  };

  return (
    <div>
      <div className="controls select-language">
        <label>
          Select language of the context menu:{' '}
          <select value={language} onChange={updateHotLanguage}>
            {languageList.map(({ languageCode }) => (
              <option key={languageCode} value={languageCode}>
                {languageCode}
              </option>
            ))}
          </select>
        </label>
      </div>

      <HotTable
        themeName="ht-theme-main"
        data={[
          ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
          ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
          ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
          ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
          ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
        ]}
        colHeaders={true}
        rowHeaders={true}
        contextMenu={true}
        height="auto"
        language={language}
        autoWrapRow={true}
        autoWrapCol={true}
        licenseKey="non-commercial-and-evaluation"
      />
    </div>
  );
};

export default ExampleComponent;

List of translatable features

Below is a list of features which can be translated:

  • Dropdown menu
  • Filtering
  • Hiding columns
  • Hiding rows
  • Nesting rows
  • Comments
  • Context menu
  • Custom borders
  • Freezing
  • Merge cells
  • Read-only

List of available languages

By default, Handsontable uses the English - United States language-country set (en-US code) for creating the text of UI elements. However, it can be used like every extra, "non-standard" language file, thus the en-US.js file can be found in /dist/languages, /languages and /src/languages folders. Currently, we also distribute extra language-country files:

  • ar-AR.js for Arabic - Global (ar-AR code). To render this language as intended, set the layout direction to RTL.
  • cs-CZ.js for Czech - Czechia (cs-CZ code).
  • de-CH.js for German - Switzerland (de-CH code).
  • de-DE.js for German - Germany (de-DE code).
  • es-MX.js for Spanish - Mexico (es-MX code).
  • fa-IR.js for Persian - Iran (fa-IR code).
  • fr-FR.js for French - France (fr-FR code).
  • hr-HR.js for Croatian - Croatia (hr-HR code).
  • it-IT.js for Italian - Italy (it-IT code).
  • ja-JP.js for Japanese - Japan (ja-JP code).
  • ko-KR.js for Korean - Korea (ko-KR code).
  • lv-LV.js for Latvian - Latvia (lv-LV code).
  • nb-NO.js for Norwegian (Bokmål) - Norway (nb-NO code).
  • nl-NL.js for Dutch - Netherlands (nl-NL code).
  • pl-PL.js for Polish - Poland (pl-PL code).
  • pt-BR.js for Portuguese - Brazil (pt-BR code).
  • ru-RU.js for Russian - Russia (ru-RU code).
  • sr-SP.js for Serbian (Latin) - Serbia (sr-SP code).
  • zh-CN.js for Chinese - China (zh-CN code).
  • zh-TW.js for Chinese - Taiwan (zh-TW code).

Create custom languages

You can create custom language sets for your implementations, or share them, as they're easily applicable to any Handsontable implementation.

Language file

It's really important for us, that the community is a important part of the growth of our library. We encourage you to create and share your translations!

Additional languages files should be placed in the src/i18n/languages folder of the Handsontable repository with name corresponding to the chosen language code (described below, for example: es-VE.js). You can incorporate your translations to the Handsontable library by sending us a pull request. It's important, that your changes are not made to the /languages and /dist/languages directories! We will generate the final files to be placed there. After that, you'll be able to use the languages in Handsontable.

You can see a full template of a sample language at the bottom of this paragraph. We're basing it on our default language pack (opens new window). Parts of the file creation process are described below.

  1. The file should start with a comment containing the translation authors (separated by commas, for example: Authors: Chris Wick, John Kyle), "last updated" date (in format: mmm dd, yyyy, for example: Last updated: Jan 01, 2017) and a description.

    /**
    * @preserve
    * Authors: Chris Wick, John Kyle
    * Last updated: Nov 15, 2017
    *
    * Description: Definition file for Spanish - Venezuela language-country.
    */
    
  2. Now, import the dictionary keys to be used in the translation.

    import * as C from '../constants';
    
  3. The language dictionary object should contain a languageCode key (in format: two lowercase letters, hyphen, two uppercase letters, for example: languageCode: 'es-PY') which will determine the language code to be used in the language property in the Handsontable settings and dictionaries keys with their corresponding translations.

    const dictionary = {
      languageCode: 'es-VE',
      [C.CONTEXTMENU_ITEMS_ROW_ABOVE]: 'Insertar fila arriba',
      ...
    }
    
  4. Lastly, place a default export of the created dictionary.

    export default dictionary;
    
  5. A simple, sample language dictionary can look like the snippet below. The /languages and /dist/languages folders will be generated by the build process. Files from those localizations can be included as shown in this section. After loading them, you will be able to use the language. You can do it by changing the language setting of Handsontable to es-VE.

    /**
    * @preserve
    * Authors: Chris Wick, John Kyle
    * Last updated: Nov 15, 2017
    *
    * Description: Definition file for Spanish - Venezuela language-country.
    */
    import * as C from '../constants';
    
    const dictionary = {
      languageCode: 'es-VE',
      [C.CONTEXTMENU_ITEMS_ROW_ABOVE]: 'Insertar fila arriba',
    };
    
    export default dictionary;
    
  6. Import already created file inside the src/i18n/languages/index.js file and export it like it's shown in the snippet below (keys in a alphabetical order).




     






     






































    import deCH from './de-CH';
    import deDE from './de-DE';
    import enUS from './en-US';
    import esVE from './es-VE';
    import plPL from './pl-PL';
    
    export {
      deCH,
      deDE,
      enUS,
      esVE,
      plPL
    };
    
  7. Voilà! You've created a language which can be used just by you or shared with others. We wait for at least 5 positive feedback from users to accept a created pull request.

Local language

You can register a language dictionary which is not a part of the Handsontable package. To do so, use the static Handsontable.languages.registerLanguageDictionary method and the static constant Handsontable.languages.dictionaryKeys which are described briefly in the next section.

const C = Handsontable.languages.dictionaryKeys;

Handsontable.languages.registerLanguageDictionary({
  languageCode: 'morse',
  // Your translation in the Morse code
  [C.FILTERS_BUTTONS_OK]: '--- -•-'
});

Use custom keys in the translation

You can register a language dictionary containing custom keys. These entries can be used like any other keys, so you're not limited to using our pre-defined constants (the ones that are present within src/i18n/constants.js file and may be accessed by Handsontable.languages.dictionaryKeys alias).

const enUSDictionary = Handsontable.languages.getLanguageDictionary('en-US');

enUSDictionary.customKey = 'Hello world';

Handsontable.languages.registerLanguageDictionary(enUSDictionary); // re-registration
Handsontable.languages.getTranslatedPhrase('en-US', 'customKey'); // 'Hello world'

Static Handsontable methods and properties

Handsontable has a few static methods and properties connected with languages. They are stored in the languages key of the global Handsontable variable. All of them are described below.

Get language dictionary for specific language code

Handsontable.languages.getLanguageDictionary(languageCode: String)

Returns: Object

Get the registered language dictionaries

Handsontable.languages.getLanguagesDictionaries()

Returns: Array

Get the phrase for specified dictionary key

Handsontable.languages.getTranslatedPhrase(languageCode: String, dictionaryKey: String, extraArguments: Mixed)

Returns: Object

Register a language dictionary for a specific language code

Handsontable.languages.registerLanguageDictionary(languageCodeOrDictionary: Mixed, dictionary: Object)

Returns: Object

Dictionary constants

Handsontable.languages.dictionaryKeys

Contains: Object

Angular Data GridLanguage

Set Handsontable's UI language to one of the built-in translations, or create your own language set using our templates.

Overview

You can easily change the text of the UI for the purpose of translating it to specific languages. We provide the developer with predefined languages, which can be applied by loading the language set and changing just one setting, and an ability to use their own language sets, created using templates of existing language files.

TIP

To properly display RTL languages, configure Handsontable's layout direction.

Load the prepared language files

To properly use the internationalization feature, you need to load the language sets. It's important that they're included after the Handsontable files. You can do it by getting the necessary files created with the UMD standard:

  1. ES modules (ESM)
import { Component } from "@angular/core";
import {
  GridSettings,
  HotTableComponent,
  HotTableModule,
} from "@handsontable/angular-wrapper";
import { registerLanguageDictionary, deDE } from "handsontable/i18n";

registerLanguageDictionary(deDE);

@Component({
  standalone: true,
  imports: [HotTableModule],
  template: ` <div>
    <hot-table themeName="ht-theme-main" [settings]="settings" />
  </div>`,
})
export class Component {
  settings: GridSettings = {
    language: deDE.languageCode,
  };
}

Demo

To see the translated context menu, right-click on a cell.

Language files were loaded after loading Handsontable.

/* file: app.component.ts */
import { Component } from '@angular/core';
import { GridSettings } from '@handsontable/angular-wrapper';
import { deDE, registerLanguageDictionary } from 'handsontable/i18n';

registerLanguageDictionary(deDE);

@Component({
  selector: 'example1-language',
  standalone: false,
  template: ` <div>
    <hot-table [data]="data" [settings]="gridSettings"></hot-table>
  </div>`,
})
export class Example1LanguageComponent {

  readonly data: Array<Array<string | number>> = [
    ['Lorem', 'ipsum', 'dolor', 'sit', '12/1/2015', 23],
    ['adipiscing', 'elit', 'Ut', 'imperdiet', '5/12/2015', 6],
    ['Pellentesque', 'vulputate', 'leo', 'semper', '10/23/2015', 26],
    ['diam', 'et', 'malesuada', 'libero', '12/1/2014', 98],
    ['orci', 'et', 'dignissim', 'hendrerit', '12/1/2016', 8.5],
  ];

  readonly gridSettings: GridSettings = {
    contextMenu: true,
    height: 'auto',
    language: 'de-DE',
    autoWrapRow: true,
    autoWrapCol: true
  };
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example1LanguageComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example1LanguageComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example1LanguageComponent ]
})

export class AppModule { }

/* file: app.component.ts */
import { Component, ViewChild } from '@angular/core';
import { GridSettings, HotTableComponent } from '@handsontable/angular-wrapper';
import { registerLanguageDictionary, getLanguagesDictionaries,
   // @ts-ignore
  arAR,
  csCZ,
  deCH,
  deDE,
  esMX,
  frFR,
  hrHR,
  itIT,
  jaJP,
  koKR,
  lvLV,
  nbNO,
  nlNL,
  plPL,
  ptBR,
  ruRU,
  srSP,
  zhCN,
  zhTW,
} from 'handsontable/i18n';

registerLanguageDictionary(arAR);
registerLanguageDictionary(csCZ);
registerLanguageDictionary(deCH);
registerLanguageDictionary(deDE);
registerLanguageDictionary(esMX);
registerLanguageDictionary(frFR);
registerLanguageDictionary(hrHR);
registerLanguageDictionary(itIT);
registerLanguageDictionary(jaJP);
registerLanguageDictionary(koKR);
registerLanguageDictionary(lvLV);
registerLanguageDictionary(nbNO);
registerLanguageDictionary(nlNL);
registerLanguageDictionary(plPL);
registerLanguageDictionary(ptBR);
registerLanguageDictionary(ruRU);
registerLanguageDictionary(srSP);
registerLanguageDictionary(zhCN);
registerLanguageDictionary(zhTW);

@Component({
  selector: 'example2-language',
  standalone: false,
  template: ` <div>
    <div class="controls select-language">
      <label>
        Select language of the context menu:
        <select [value]="language" (change)="updateHotLanguage($event)">
          <option *ngFor="let lang of languageList" [value]="lang">
            {{ lang }}
          </option>
        </select>
      </label>
    </div>
    <div>
      <hot-table [data]="data" [settings]="gridSettings"></hot-table>
    </div>
  </div>`,
})
export class Example2LanguageComponent {
  @ViewChild(HotTableComponent, { static: false }) readonly hotTable!: HotTableComponent;

  readonly data: Array<Array<string | number>> = [
    ['A1', 'B1', 'C1', 'D1', 'E1', 'F1', 'G1', 'H1', 'I1', 'J1'],
    ['A2', 'B2', 'C2', 'D2', 'E2', 'F2', 'G2', 'H2', 'I2', 'J2'],
    ['A3', 'B3', 'C3', 'D3', 'E3', 'F3', 'G3', 'H3', 'I3', 'J3'],
    ['A4', 'B4', 'C4', 'D4', 'E4', 'F4', 'G4', 'H4', 'I4', 'J4'],
    ['A5', 'B5', 'C5', 'D5', 'E5', 'F5', 'G5', 'H5', 'I5', 'J5'],
  ];

  readonly languageList = getLanguagesDictionaries().map(
    (item) => item.languageCode
  );

  language = 'en-US';

  readonly gridSettings: GridSettings = {
    colHeaders: true,
    rowHeaders: true,
    contextMenu: true,
    height: 'auto',
    language: this.language,
    autoWrapRow: true,
    autoWrapCol: true
  };

  updateHotLanguage(event: any): void {
    this.language = event.target.value;
    this.hotTable?.hotInstance?.updateSettings({ language: this.language });
  }
}



/* file: app.module.ts */
import { NgModule, ApplicationConfig } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { registerAllModules } from 'handsontable/registry';
import { HOT_GLOBAL_CONFIG, HotGlobalConfig, HotTableModule } from '@handsontable/angular-wrapper';
import { CommonModule } from '@angular/common';
import { NON_COMMERCIAL_LICENSE } from '@handsontable/angular-wrapper';
import { Example2LanguageComponent } from './app.component';

// register Handsontable's modules
registerAllModules();

export const appConfig: ApplicationConfig = {
  providers: [
    {
      provide: HOT_GLOBAL_CONFIG,
      useValue: {
        themeName: 'ht-theme-main',
        license: NON_COMMERCIAL_LICENSE,
      } as HotGlobalConfig
    }
  ],
};

@NgModule({
  imports: [ BrowserModule, HotTableModule, CommonModule ],
  declarations: [ Example2LanguageComponent ],
  providers: [...appConfig.providers],
  bootstrap: [ Example2LanguageComponent ]
})

export class AppModule { }

List of translatable features

Below is a list of features which can be translated:

  • Dropdown menu
  • Filtering
  • Hiding columns
  • Hiding rows
  • Nesting rows
  • Comments
  • Context menu
  • Custom borders
  • Freezing
  • Merge cells
  • Read-only

List of available languages

By default, Handsontable uses the English - United States language-country set (en-US code) for creating the text of UI elements. However, it can be used like every extra, "non-standard" language file, thus the en-US.js file can be found in /dist/languages, /languages and /src/languages folders. Currently, we also distribute extra language-country files:

  • ar-AR.js for Arabic - Global (ar-AR code). To render this language as intended, set the layout direction to RTL.
  • cs-CZ.js for Czech - Czechia (cs-CZ code).
  • de-CH.js for German - Switzerland (de-CH code).
  • de-DE.js for German - Germany (de-DE code).
  • es-MX.js for Spanish - Mexico (es-MX code).
  • fa-IR.js for Persian - Iran (fa-IR code).
  • fr-FR.js for French - France (fr-FR code).
  • hr-HR.js for Croatian - Croatia (hr-HR code).
  • it-IT.js for Italian - Italy (it-IT code).
  • ja-JP.js for Japanese - Japan (ja-JP code).
  • ko-KR.js for Korean - Korea (ko-KR code).
  • lv-LV.js for Latvian - Latvia (lv-LV code).
  • nb-NO.js for Norwegian (Bokmål) - Norway (nb-NO code).
  • nl-NL.js for Dutch - Netherlands (nl-NL code).
  • pl-PL.js for Polish - Poland (pl-PL code).
  • pt-BR.js for Portuguese - Brazil (pt-BR code).
  • ru-RU.js for Russian - Russia (ru-RU code).
  • sr-SP.js for Serbian (Latin) - Serbia (sr-SP code).
  • zh-CN.js for Chinese - China (zh-CN code).
  • zh-TW.js for Chinese - Taiwan (zh-TW code).

Create custom languages

You can create custom language sets for your implementations, or share them, as they're easily applicable to any Handsontable implementation.

Language file

It's really important for us, that the community is a important part of the growth of our library. We encourage you to create and share your translations!

Additional languages files should be placed in the src/i18n/languages folder of the Handsontable repository with name corresponding to the chosen language code (described below, for example: es-VE.js). You can incorporate your translations to the Handsontable library by sending us a pull request. It's important, that your changes are not made to the /languages and /dist/languages directories! We will generate the final files to be placed there. After that, you'll be able to use the languages in Handsontable.

You can see a full template of a sample language at the bottom of this paragraph. We're basing it on our default language pack (opens new window). Parts of the file creation process are described below.

  1. The file should start with a comment containing the translation authors (separated by commas, for example: Authors: Chris Wick, John Kyle), "last updated" date (in format: mmm dd, yyyy, for example: Last updated: Jan 01, 2017) and a description.

    /**
    * @preserve
    * Authors: Chris Wick, John Kyle
    * Last updated: Nov 15, 2017
    *
    * Description: Definition file for Spanish - Venezuela language-country.
    */
    
  2. Now, import the dictionary keys to be used in the translation.

    import * as C from '../constants';
    
  3. The language dictionary object should contain a languageCode key (in format: two lowercase letters, hyphen, two uppercase letters, for example: languageCode: 'es-PY') which will determine the language code to be used in the language property in the Handsontable settings and dictionaries keys with their corresponding translations.

    const dictionary = {
      languageCode: 'es-VE',
      [C.CONTEXTMENU_ITEMS_ROW_ABOVE]: 'Insertar fila arriba',
      ...
    }
    
  4. Lastly, place a default export of the created dictionary.

    export default dictionary;
    
  5. A simple, sample language dictionary can look like the snippet below. The /languages and /dist/languages folders will be generated by the build process. Files from those localizations can be included as shown in this section. After loading them, you will be able to use the language. You can do it by changing the language setting of Handsontable to es-VE.

    /**
    * @preserve
    * Authors: Chris Wick, John Kyle
    * Last updated: Nov 15, 2017
    *
    * Description: Definition file for Spanish - Venezuela language-country.
    */
    import * as C from '../constants';
    
    const dictionary = {
      languageCode: 'es-VE',
      [C.CONTEXTMENU_ITEMS_ROW_ABOVE]: 'Insertar fila arriba',
    };
    
    export default dictionary;
    
  6. Import already created file inside the src/i18n/languages/index.js file and export it like it's shown in the snippet below (keys in a alphabetical order).




     






     






































    import deCH from './de-CH';
    import deDE from './de-DE';
    import enUS from './en-US';
    import esVE from './es-VE';
    import plPL from './pl-PL';
    
    export {
      deCH,
      deDE,
      enUS,
      esVE,
      plPL
    };
    
  7. Voilà! You've created a language which can be used just by you or shared with others. We wait for at least 5 positive feedback from users to accept a created pull request.

Local language

You can register a language dictionary which is not a part of the Handsontable package. To do so, use the static Handsontable.languages.registerLanguageDictionary method and the static constant Handsontable.languages.dictionaryKeys which are described briefly in the next section.

const C = Handsontable.languages.dictionaryKeys;

Handsontable.languages.registerLanguageDictionary({
  languageCode: 'morse',
  // Your translation in the Morse code
  [C.FILTERS_BUTTONS_OK]: '--- -•-'
});

Use custom keys in the translation

You can register a language dictionary containing custom keys. These entries can be used like any other keys, so you're not limited to using our pre-defined constants (the ones that are present within src/i18n/constants.js file and may be accessed by Handsontable.languages.dictionaryKeys alias).

const enUSDictionary = Handsontable.languages.getLanguageDictionary('en-US');

enUSDictionary.customKey = 'Hello world';

Handsontable.languages.registerLanguageDictionary(enUSDictionary); // re-registration
Handsontable.languages.getTranslatedPhrase('en-US', 'customKey'); // 'Hello world'

Static Handsontable methods and properties

Handsontable has a few static methods and properties connected with languages. They are stored in the languages key of the global Handsontable variable. All of them are described below.

Get language dictionary for specific language code

Handsontable.languages.getLanguageDictionary(languageCode: String)

Returns: Object

Get the registered language dictionaries

Handsontable.languages.getLanguagesDictionaries()

Returns: Array

Get the phrase for specified dictionary key

Handsontable.languages.getTranslatedPhrase(languageCode: String, dictionaryKey: String, extraArguments: Mixed)

Returns: Object

Register a language dictionary for a specific language code

Handsontable.languages.registerLanguageDictionary(languageCodeOrDictionary: Mixed, dictionary: Object)

Returns: Object

Dictionary constants

Handsontable.languages.dictionaryKeys

Contains: Object